﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Flight_Data_Recorder
{
    class DataReadWrite
    {
        
        public static string[] FieldNames
        {     
            get
            {
                string[] fields = new string[9];
                fields[0] = "ID";
                fields[1] = "Lat";
                fields[2] = "Long";
                fields[3] = "Alt";
                fields[4] = "Heading";
                fields[5] = "Bank";
                fields[6] = "Pitch";
                fields[7] = "Airspeed";
                fields[8] = "VertSpeed";
                return fields;
            }
        }

        public static List<string[]> ReadFile(string path)
        {
            List<string[]> parsedData = new List<string[]>();

            try
            {
                using (StreamReader readFile = new StreamReader(path))
                {
                    string line;
                    string[] row;

                    while ((line = readFile.ReadLine()) != null)
                    {
                        row = line.Split(',');
                        parsedData.Add(row);
                    }
                }
            }
            catch (Exception e)
            {
            }

            return parsedData;
        }

        public static double[] GetDataLine(int line, string path)
        {
            double[] returnValues = new double[9];
            string[][] parsedData = ReadFile(path).ToArray();

            if (line != 0)
            {
                for (int i = 0; i < 9; i++)
                {
                    returnValues[i] = Convert.ToDouble(parsedData[line][i]);
                }
                return returnValues; 
            }
            return null;
        }

        public static void CreateFileWithHeaders(string path)
        {
            StreamWriter sw = new StreamWriter(path);
            string output = "";
            for (int i = 0; i <= 8; i++)
            {
                output += FieldNames[i] + ",";
            }
            output += "\r";
            sw.Write(output);
            sw.Close();
        }

        public static void WriteNewLine(string path, double[] data)
        {
            if (path != "")
            {
                StreamWriter writer = new StreamWriter(path, true);
                string output = "";
                for (int i = 0; i < 9; i++)
                {
                    output += data[i].ToString() + ",";
                }
                writer.WriteLine(output);
                writer.Close();
            }
        }

        public static int GetNumberOfLinesInFile(string path)
        {
            var lineCount = 0;
            using (var reader = File.OpenText(path))//opens current file
            {
                while (reader.ReadLine() != null)
                {
                    lineCount++;//adds one to the line count
                }
            }
            return lineCount;
        }
    }
}
