﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Flight_Data_Recorder
{
    class FSData
    {
        private static long ttts = 4294967296;// 2^32

        public static double GetLatitude()
        {
            FsuipcSdk.Fsuipc fsuipc = new FsuipcSdk.Fsuipc();
            fsuipc.FSUIPC_Initialization();
            int resultValue = -1;
            int token = -1;

            double latHi;
            double latLo;
            double latitude;

            fsuipc.FSUIPC_Open(0, ref resultValue);

            fsuipc.FSUIPC_Read(0x0564, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            latHi = resultValue;

            fsuipc.FSUIPC_Read(0x0560, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            latLo = resultValue;


            if (latLo != 0)
            {
                latLo = latLo / (65536.0 * 65536.0);
            }
            if (latHi > 0)
            {
                latitude = latHi + latLo;
            }
            else
            {
                latitude = latHi - latLo;
            }
            latitude = latitude * 90.0 / 10001750.0;

            fsuipc.FSUIPC_Close();
            return latitude;

        }
        public static double GetLongitude()
        {
            FsuipcSdk.Fsuipc fsuipc = new FsuipcSdk.Fsuipc();
            fsuipc.FSUIPC_Initialization();
            int resultValue = -1;
            int token = -1;
            fsuipc.FSUIPC_Open(0, ref resultValue);

            double longHi;
            double longLo;
            double longitude;

            fsuipc.FSUIPC_Read(0x056C, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            longHi = resultValue;

            fsuipc.FSUIPC_Read(0x0568, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            longLo = resultValue;


            if (longLo != 0)
            {
                longLo = longLo / (65536.0 * 65536.0);
            }
            if (longHi > 0)
            {
                longitude = longHi + longLo;
            }
            else
            {
                longitude = longHi - longLo;
            }
            longitude = longitude * 360.0 / (65536.0 * 65536.0);

            fsuipc.FSUIPC_Close();
            return longitude;
        }
        public static double GetAltitude()
        {
            FsuipcSdk.Fsuipc fsuipc = new FsuipcSdk.Fsuipc();
            fsuipc.FSUIPC_Initialization();
            int resultValue = -1;
            int token = -1;
            int AltLo = 0;
            int AltHi = 0;
            double Alt = 0;
            fsuipc.FSUIPC_Open(0, ref resultValue);

            fsuipc.FSUIPC_Read(0x0574, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            AltHi = resultValue;

            fsuipc.FSUIPC_Read(0x0570, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            AltLo = resultValue;

            Alt = AltLo;
            Alt = Alt / 4294967296;
            Alt = Alt + AltHi;

            Alt = Alt * 3.2808399;

            return Alt;
        }
        public static double GetHeading()
        {
            FsuipcSdk.Fsuipc fsuipc = new FsuipcSdk.Fsuipc();
            fsuipc.FSUIPC_Initialization();
            int resultValue = -1;
            int token = -1;
            double heading = 0;       
            fsuipc.FSUIPC_Open(0, ref resultValue);

            fsuipc.FSUIPC_Read(0x0580, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            heading = resultValue;

            heading = heading * 360 / ttts;

            return heading;
        }
        public static double GetBank()
        {
            FsuipcSdk.Fsuipc fsuipc = new FsuipcSdk.Fsuipc();
            fsuipc.FSUIPC_Initialization();
            int resultValue = -1;
            int token = -1;
            double bank = 0;
            fsuipc.FSUIPC_Open(0, ref resultValue);

            fsuipc.FSUIPC_Read(0x057C, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            bank = resultValue;

            bank = bank * 360 / ttts;

            return bank;  
        }
        public static double GetPitch()
        {
            FsuipcSdk.Fsuipc fsuipc = new FsuipcSdk.Fsuipc();
            fsuipc.FSUIPC_Initialization();
            int resultValue = -1;
            int token = -1;
            double pitch = 0;
            fsuipc.FSUIPC_Open(0, ref resultValue);

            fsuipc.FSUIPC_Read(0x0578, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            pitch = resultValue;

            pitch = pitch * 360 / ttts;

            return pitch; 
        }
        public static double GetAirpeed()
        {
            FsuipcSdk.Fsuipc fsuipc = new FsuipcSdk.Fsuipc();
            fsuipc.FSUIPC_Initialization();
            int resultValue = -1;
            int token = -1;
            double speed = 0;
            fsuipc.FSUIPC_Open(0, ref resultValue);

            fsuipc.FSUIPC_Read(0x02BC, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            speed = resultValue;
            speed = speed / 128;

            return speed; 
        }

        public static double[] GetAircraftDataArray()
        {
            FsuipcSdk.Fsuipc fsuipc = new FsuipcSdk.Fsuipc();
            fsuipc.FSUIPC_Initialization();
            int resultValue = 0;
            double[] returnValue = new double[9];
            int token = -1;

            fsuipc.FSUIPC_Open(0, ref resultValue);

            //DECLARATIONS
            double longHi;
            double longLo;
            double longitude;
            double latHi;
            double latLo;
            double latitude;
            int AltLo = 0;
            int AltHi = 0;
            double Alt = 0;
            double heading = 0;
            double bank = 0;
            double pitch = 0;
            double speed = 0;
            double vertspeed = 0;
            double variation = 0;


            //READING DATA
            fsuipc.FSUIPC_Read(0x056C, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            longHi = resultValue;

            fsuipc.FSUIPC_Read(0x0568, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            longLo = resultValue;

            fsuipc.FSUIPC_Read(0x0564, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            latHi = resultValue;

            fsuipc.FSUIPC_Read(0x0560, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            latLo = resultValue;

            fsuipc.FSUIPC_Read(0x0574, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            AltHi = resultValue;

            fsuipc.FSUIPC_Read(0x0570, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            AltLo = resultValue;

            fsuipc.FSUIPC_Read(0x0580, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            heading = resultValue;

            fsuipc.FSUIPC_Read(0x057C, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            bank = resultValue;

            fsuipc.FSUIPC_Read(0x0578, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            pitch = resultValue;

            fsuipc.FSUIPC_Read(0x02BC, 4, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            speed = resultValue;

            fsuipc.FSUIPC_Read(0x0842, 2, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            vertspeed = resultValue;

            fsuipc.FSUIPC_Read(0x02A0, 2, ref token, ref resultValue);
            fsuipc.FSUIPC_Process(ref resultValue);
            fsuipc.FSUIPC_Get(ref token, ref resultValue);
            variation = resultValue;

            //FIRST LAYER CALULATIONS
            if (latLo != 0)
            {
                latLo = latLo / (65536.0 * 65536.0);
            }
            if (latHi > 0)
            {
                latitude = latHi + latLo;
            }
            else
            {
                latitude = latHi - latLo;
            }
            if (longLo != 0)
            {
                longLo = longLo / (65536.0 * 65536.0);
            }
            if (longHi > 0)
            {
                longitude = longHi + longLo;
            }
            else
            {
                longitude = longHi - longLo;
            }
            Alt = AltLo;
            Alt = Alt / 4294967296;
            Alt = Alt + AltHi;
            variation = variation * 360 / 65536;
            

            //FINAL CALCULATIONS
            returnValue[1] = latitude * 90.0 / 10001750.0;
            returnValue[2] = longitude * 360.0 / (65536.0 * 65536.0);
            returnValue[3] = Alt * 3.2808399;
            returnValue[4] = (heading * 360 / ttts) - variation;
            returnValue[5] = bank * 360 / ttts;
            returnValue[6] = pitch * 360 / ttts;
            returnValue[7] = speed/128;
            returnValue[8] = vertspeed / (-3.28084);

            fsuipc.FSUIPC_Close();
            return returnValue;

        }
    }
}
